% Initialize variables
num1 = 0;
num2 = 0;
result = 0;
operation = '';

% User interface
disp('Welcome to the Basic Calculator!');

while true
  % Get user input
  num1 = input('Enter first number: ');
  operation = input('Select operation (+, -, *, /): ', 's');
  num2 = input('Enter second number: ');

  % Perform calculation based on operation
  switch operation
    case '+'
      result = num1 + num2;
    case '-'
      result = num1 - num2;
    case '*'
      result = num1 * num2;
    case '/'
      if num2 == 0
        error('Division by zero');
      else
        result = num1 / num2;
      end
    otherwise
      error('Invalid operation');
  end

  % Display result
  disp(['Result: ', num2str(result)]);

  % Ask user to continue
  choice = input('Do you want to continue (Y/N)? ', 's');
  if choice ~= 'Y' && choice ~= 'y'
    break;
  end
end

disp('Thank you for using the Basic Calculator!');
